
<%@ Page Async="true" Title="WebDAV" Language="C#" AutoEventWireup="true" Inherits="WebDAVServer.NtfsStorage.MyCustomHandlerPage"%>
<%@ Import Namespace="ITHit.WebDAV.Server.Class1" %>
<!DOCTYPE html>
<html lang="en">
<head>
    <title>IT Hit WebDAV Server Engine</title>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport"
          content="width=device-width, initial-scale=1.0, user-scalable=0, minimum-scale=1.0, maximum-scale=1.0">

    <link href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <style>
        .navbar-header {
            padding: 15px;
            font-size: 18px;
            color: #9d9d9d;
        }
        .ithit-search-container {
            position: relative;
        }

        .ithit-search-container .twitter-typeahead {
            position: relative;
            width: 100%;
            padding: 0 100px 0 0;
            margin-bottom: 15px;
        }

        .ithit-search-container button {
            position: absolute;
            top: 0;
            right: 0;
            width: 85px;
        }

        .tt-hint {
            color: #999
        }

        .tt-menu {
            right: 100px;
            margin: 1px 0;
            padding: 6px 0;
            background-color: #fff;
            border: 1px solid #ccc;
            -webkit-border-radius: 4px;
            border-radius: 4px;
            -webkit-box-shadow: 0 6px 12px rgba(0, 0, 0, .175);
            box-shadow: 0 6px 12px rgba(0, 0, 0, .175);
        }

        .tt-suggestion {
            padding: 3px 20px;
            line-height: 1.7;
        }

        .tt-suggestion:hover {
            cursor: pointer;
            background-color: #eee;
        }

        .tt-suggestion.tt-cursor {
            background-color: #eee;
        }
    </style>
</head>
<body>
<nav class="navbar navbar-inverse navbar-static-top">
    <div class="container-fluid">
        <div class="navbar-header">
            IT Hit WebDAV Server Engine v<%=System.Reflection.Assembly.GetAssembly(typeof(ITHit.WebDAV.Server.DavEngineAsync)).GetName().Version%>
        </div>
    </div>
</nav>

<div class="container-fluid">
    <div class="row">
        <div class="col-md-8">
            <ul class="breadcrumb ithit-breadcrumb-container"></ul>

            <div class="ithit-search-container">
                <input class="form-control" type="text"/>
                <button type="button" class="btn btn-primary">
                    Search
                </button>
            </div>

            <div class="table-responsive">
                <table class="table table-hover ithit-grid-container">
                    <colgroup>
                        <col width="40"/>
                        <col width="32"/>
                        <col/>
                        <col width="100"/>
                        <col width="180"/>
                        <col/>
                    </colgroup>
                    <thead>
                    <tr>
                        <th>#</th>
                        <th></th>
                        <th>Display Name</th>
                        <th>Size</th>
                        <th>Modified</th>
                        <th></th>
                    </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
        <div class="col-md-4">
            <p>
                This page is displayed when user accesses any folder on your WebDAV server in a web browser.
                You can customize this page to your needs.
            </p>

            <p>
                Examine the MyCustomHandlerPage.html/aspx in your project to see how to <a href="https://www.webdavsystem.com/ajax/programming/" target="_blank">list folder content</a>
                and to use IT Hit WebDAV Ajax Library to <a href="https://www.webdavsystem.com/ajax/programming/opening_ms_office_docs" target="_blank">open documents for editing</a>.
            </p>

            <hr/>

            <h3>Test Your Server</h3>

            <p>
                To test your WebDAV server you can run Ajax integration tests right from this page.
            </p>
            <a href="javascript:void(0)" onclick="OpenTestsWindow()" class="btn btn-default">Run Integration Tests</a>

            <hr/>

            <h3>Manage Docs with Ajax File Browser</h3>

            <p>
                Use the <a href="https://www.webdavsystem.com/ajaxfilebrowser/programming/">IT Hit Ajax File Browser</a> to browse your documents, open for editing from a web page and
                uploading with pause/resume and auto-restore upload.
            </p>
            <a href="javascript:void(0)" onclick="OpenAjaxFileBrowserWindow()" class="btn btn-default">Browse Using Ajax File Browser</a>

            <hr/>

            <h3>Connect with WebDAV Client</h3>

            <p>
                Use a WebDAV client provided with almost any OS. Refer to <a href="https://www.webdavsystem.com/server/access">Accessing WebDAV Server</a> page for
                detailed instructions. The button below is using <a href="https://www.webdavsystem.com/ajax/">IT Hit WebDAV Ajax Library</a> to mount WebDAV
                folder and open the default OS file manager.
            </p>
            <a href="javascript:void(0)" onclick="WebDavController && WebDavController.OpenCurrentFolderInOsFileManager()" class="btn btn-default">Browse Using OS File Manager</a>

            <br/>
            <br/>
        </div>
    </div>
</div>

<!--
    JavaScript file required to run WebDAV Ajax library is loaded from IT Hit website.
    To load files from your website download them here: https://www.webdavsystem.com/ajax/download,
    deploy them to your website and replace the 'https://www.ajaxbrowser.com/ITHitService/' path in this file.
-->
<script src="https://www.ajaxbrowser.com/ITHitService/WebDAVAJAXLibrary/ITHitWebDAVClient.js"
        type="text/javascript"></script>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/typeahead.js/0.11.1/typeahead.jquery.min.js"></script>
<script>

    function OpenAjaxFileBrowserWindow() {
        window.open("<%=Request.ApplicationPath.TrimEnd('/')%>/AjaxFileBrowser/AjaxFileBrowser.aspx", "", "menubar=1,location=1,status=1,scrollbars=1,resizable=1,width=900,height=600");
    }

    function OpenTestsWindow() {
        var width = Math.round(screen.width * 0.5);
        var height = Math.round(screen.height * 0.8);
        window.open("<%=Request.ApplicationPath.TrimEnd('/')%>/AjaxFileBrowser/AjaxIntegrationTests.aspx", "", "menubar=1,location=1,status=1,scrollbars=1,resizable=1,width=" + width + ",height=" + height);
    }

    (function () {

        ///////////////////
        // Folder Grid View

        var FolderGridView = function (selector) {
            this.$el = $(selector);
        };
        FolderGridView.prototype = {

            Render: function (aItems) {
                // Sort by display name
                if (''.localeCompare) {
                    aItems.sort(function (a, b) {
                        return a.DisplayName.localeCompare(b.DisplayName);
                    });
                } else {
                    aItems.sort(function (a, b) {
                        return a.DisplayName < b.DisplayName ? -1 : (a.DisplayName > b.DisplayName ? 1 : 0);
                    });
                }

                // Folders at first
                aItems = []
                        .concat(aItems.filter(function (oItem) {
                            return oItem.IsFolder()
                        }))
                        .concat(aItems.filter(function (oItem) {
                            return !oItem.IsFolder()
                        }));

                this.$el.find('tbody').html(
                        aItems.map(function (oItem, i) {
                            /** @type {ITHit.WebDAV.Client.HierarchyItem} oItem */
                            return $('<tr />').html([
                                $('<td />').text(i + 1),
                                $('<td />').html(oItem.IsFolder() ? '<span class="glyphicon glyphicon-folder-open"></span>' : ''),
                                oItem.IsFolder() ? $('<td />').html($('<a />').text(oItem.DisplayName).attr('href', oItem.Href)) : $('<td />').text(oItem.DisplayName),
                                $('<td />').text(!oItem.IsFolder() ? this._FormatFileSize(oItem.ContentLength) : '').css('text-align', 'right'),
                                $('<td />').text(this._FormatDate(oItem.LastModified)),
                                $('<td />').html(oItem.IsFolder() ?
                                        $('<a />').text('Browse').attr('href', 'javascript:void(0)').attr('title', 'Open folder in OS File Manager').on('click', function () {
                                            oWebDav.OpenFolderInOsFileManager(oItem.Href)
                                        }) :
                                        $('<a />').text('Edit').attr('href', 'javascript:void(0)').attr('title', 'Edit in associated application').on('click', function () {
                                            oWebDav.EditDocument(oItem.Href)
                                        })
                                )
                            ])
                        }.bind(this))
                );
            },

            _FormatFileSize: function (iSize) {
                if (!iSize) {
                    return '0 B';
                }
                var i = Math.floor(Math.log(iSize) / Math.log(1024));
                return ( iSize / Math.pow(1024, i) ).toFixed(2) * 1 + ' ' + ['B', 'kB', 'MB', 'GB', 'TB'][i];
            },

            _FormatDate: function (oDate) {
                return [
                    ('0' + (oDate.getMonth() + 1)).slice(-2),
                    ('0' + oDate.getDate()).slice(-2),
                    oDate.getFullYear()
                ].join('/') +
                        ' ' +
                        [
                            ('0' + oDate.getHours() % 12 || 12).slice(-2),
                            ('0' + oDate.getMinutes()).slice(-2),
                            ('0' + oDate.getSeconds()).slice(-2)
                        ].join(':') +
                        ' ' +
                        (oDate.getHours() > 12 ? 'PM' : 'AM')
            }

        };

        ///////////////////
        // Search Form View

        var SearchFormView = function (selector) {
            this.$el = $(selector);
            this.Init();
        };
        SearchFormView.prototype = {

            Init: function () {
                this.$el.find('button').on('click', this._OnSubmit.bind(this));
                this.$el.find('input')
                        .typeahead({},
                                {
                                    name: 'states',
                                    display: 'title',
                                    templates: {
                                        suggestion: this._RenderSuggestion.bind(this)
                                    },
                                    async: true,
                                    source: this._Source.bind(this)
                                }
                        )
                        .on('keyup', this._OnKeyUp.bind(this))
                        .on('typeahead:select', this._OnSelect.bind(this));
            },

            SetDisabled: function (bIsDisabled) {
                this.$el.find('button').prop('disabled', bIsDisabled);
                this.$el.find('input')
                        .prop('disabled', bIsDisabled)
                        .attr('placeholder', !bIsDisabled ? '' : 'The server does not support search');
            },

            GetValue: function () {
                return this.$el.find('input.tt-input').val();
            },

            _Source: function (sPhrase, c, fCallback) {
                oWebDav.Search(sPhrase, true, function (aItems) {
                    fCallback(aItems.map(function (oItem) {
                        return {
                            id: oItem.Href,
                            title: oItem.DisplayName,
                            item: oItem
                        };
                    }));
                })
            },

            _OnKeyUp: function (oEvent) {
                if (oEvent.keyCode === 13) {
                    oWebDav.Search(oSearchForm.GetValue(), false, function (aItems) {
                        oFolderGrid.Render(aItems);
                    });
                }
            },

            _OnSelect: function (oEvent, oSelected) {
                oFolderGrid.Render([oSelected.item]);
            },

            _OnSubmit: function () {
                oWebDav.Search(oSearchForm.GetValue(), false);
            },

            _RenderSuggestion: function (oData) {
                return '<div>' + oData.title + '</div>';
            }

        };

        ///////////////////
        // Breadcrumbs View

        var BreadcrumbsView = function (selector) {
            this.$el = $(selector);
        };
        BreadcrumbsView.prototype = {

            /**
             * @param {ITHit.WebDAV.Client.HierarchyItem} oItem
             */
            SetHierarchyItem: function (oItem) {
                var aParts = oItem.Href
                    .split('/')
                    .slice(2)
                    .filter(function (v) {
                        return v;
                    });

                this.$el.html(aParts.map(function (sPart, i) {
                    var bIsLast = aParts.length === i + 1;
                    var oLabel = i === 0 ? $('<span />').addClass('glyphicon glyphicon-home') : $('<span />').text(decodeURIComponent(sPart));
                    return $('<li />').toggleClass('active', bIsLast).append(
                            bIsLast ?
                                    $('<span />').html(oLabel) :
                                    $('<a />').attr('href', location.protocol + '//' + aParts.slice(0, i + 1).join('/') + '/').html(oLabel)
                    );
                }));
            }

        };

        /////////////////////////
        // History Api Controller
        var HistoryApiController = function (selector) {
            this.$container = $(selector);
            this.Init();
        };
        HistoryApiController.prototype = {

            Init: function () {
                if (!this._IsBrowserSupport()) {
                    return;
                }

                window.addEventListener('popstate', this._OnPopState.bind(this), false);
                this.$container.on('click', this._OnLinkClick.bind(this));
            },

            _OnPopState: function(oEvent) {
                var sUrl = oEvent.state && oEvent.state.Url || location.href;
                oWebDav.OpenFolder(sUrl);
            },

            _OnLinkClick: function(oEvent) {
                var sUrl = $(oEvent.target).closest('a').attr('href');
                if (!sUrl) {
                    return;
                }

                if (sUrl.indexOf(location.origin) !== 0) {
                    return;
                }

                oEvent.preventDefault();

                history.pushState({Url: sUrl}, '', sUrl);
                oWebDav.OpenFolder(sUrl);
            },

            _IsBrowserSupport: function () {
                return !!(window.history && history.pushState);
            }

        };

        /////////////////////
        // Web Dav Controller

        var WebDavController = function () {
            this.CurrentFolder = null;
            this.WebDavSession = new ITHit.WebDAV.Client.WebDavSession();

        };
        WebDavController.prototype = {

            Refresh: function () {
                if (this.CurrentFolder) {
                    this.OpenFolder(this.CurrentFolder.Href);
                }
            },

            OpenFolder: function (sPath) {
                this.WebDavSession.OpenFolderAsync(sPath, [], function (oResponse) {
                    this.CurrentFolder = oResponse.Result;
                    oBreadcrumbs.SetHierarchyItem(this.CurrentFolder);

                    // Detect search support. If search is not supported - disable search field.
                    this.CurrentFolder.GetSupportedFeaturesAsync(function (oResult) {
                        /** @typedef {ITHit.WebDAV.Client.OptionsInfo} oOptionsInfo */
                        var oOptionsInfo = oResult.Result;

                        oSearchForm.SetDisabled(!(oOptionsInfo.Features & ITHit.WebDAV.Client.Features.Dasl));
                    });

                    this.CurrentFolder.GetChildrenAsync(false, [], function (oResult) {
                        /** @type {ITHit.WebDAV.Client.HierarchyItem[]} aItems */
                        var aItems = oResult.Result;

                        oFolderGrid.Render(aItems);
                    })
                }.bind(this));
            },

            Search: function (sPhrase, bIsDynamic, fCallback) {
                if (!this.CurrentFolder) {
                    fCallback && fCallback([]);
                    return;
                }

                if (sPhrase === '') {
                    this.Refresh();
                    return;
                }

                var searchQuery = new ITHit.WebDAV.Client.SearchQuery();
                searchQuery.Phrase = sPhrase + '%';
                searchQuery.EnableContains = !bIsDynamic;

                this.CurrentFolder.SearchByQueryAsync(searchQuery, function (oResult) {
                    /** @type {ITHit.WebDAV.Client.AsyncResult} oResult */

                    /** @type {ITHit.WebDAV.Client.HierarchyItem[]} aItems */
                    var aItems = oResult.Result;

                    fCallback && fCallback(aItems);
                });
            },

            /**
             * Opens document for editing.
             * @param {string} sDocumentUrl Must be full path including domain name: https://webdavserver.com/path/file.ext
             */
            EditDocument: function (sDocumentUrl) {

                ITHit.WebDAV.Client.DocManager.EditDocument(sDocumentUrl, this._GetMountUrl(), this._OnOpenError.bind(this));
            },

            /**
             * Opens current folder in OS file manager.
             */
            OpenCurrentFolderInOsFileManager: function () {
                this.OpenFolderInOsFileManager(this.CurrentFolder.Href);
            },

            /**
             * Opens folder in OS file manager.
             * @param {string} sFolderUrl Must be full path including domain name: https://webdavserver.com/path/
             */
            OpenFolderInOsFileManager: function (sFolderUrl) {

                ITHit.WebDAV.Client.DocManager.OpenFolderInOsFileManager(sFolderUrl, this._GetMountUrl(), this._OnOpenError.bind(this));
            },

            /**
             * @return {string}
             **/
            _GetMountUrl: function () {
                // Web Folders on Windows XP require port, even if it is a default port 80 or 443.
                var port = window.location.port || (window.location.protocol == 'http:' ? 80 : 443);

                return window.location.protocol + '//' + window.location.hostname + ':' + port + '<%=Request.ApplicationPath.TrimEnd('/')%>/';
            },

            /**
             * Function to be called when document or OS file manager failed to open.
             * @private
             */
            _OnOpenError: function () {
                if (confirm('This action requires a protocol installation. Select OK to download the protocol installer.')) {

                    // IT Hit WebDAV Ajax Library protocol installers path.
                    // Used to open non-MS Office documents or if MS Office is
                    // not installed as well as to open OS File Manager.
                    var installersFolderPath = 'https://www.ajaxbrowser.com/ITHitService/WebDAVAJAXLibrary/Plugins/';

                    var installerFilePath = installersFolderPath + ITHit.WebDAV.Client.DocManager.GetInstallFileName();
                    window.open(installerFilePath);
                }
            }

        };

        var oFolderGrid = new FolderGridView('.ithit-grid-container');
        var oSearchForm = new SearchFormView('.ithit-search-container');
        var oBreadcrumbs = new BreadcrumbsView('.ithit-breadcrumb-container');
        var oHistoryApi = new HistoryApiController('.ithit-grid-container, .ithit-breadcrumb-container');
        var oWebDav = window.WebDavController = new WebDavController();

        // List files on a WebDAV server using WebDAV Ajax Library
        oWebDav.OpenFolder(location.href);
    })();
</script>
</body>
</html>